/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VRedcapLogicRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VRedcapLogic extends TableImpl<VRedcapLogicRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_redcap_logic</code>
     */
    public static final VRedcapLogic V_REDCAP_LOGIC = new VRedcapLogic();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VRedcapLogicRecord> getRecordType() {
        return VRedcapLogicRecord.class;
    }

    /**
     * The column <code>common_dd.v_redcap_logic.unique_name</code>.
     */
    public final TableField<VRedcapLogicRecord, String> UNIQUE_NAME = createField(DSL.name("unique_name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_redcap_logic.logictype_descr</code>.
     */
    public final TableField<VRedcapLogicRecord, String> LOGICTYPE_DESCR = createField(DSL.name("logictype_descr"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_redcap_logic.redcaprule</code>.
     */
    public final TableField<VRedcapLogicRecord, String> REDCAPRULE = createField(DSL.name("redcaprule"), SQLDataType.CLOB, this, "");

    private VRedcapLogic(Name alias, Table<VRedcapLogicRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VRedcapLogic(Name alias, Table<VRedcapLogicRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_redcap_logic" as  WITH ands(fk_andrgp, redcaprule) AS (
                SELECT c.fk_andgrp,
                   format('[%s]%s%s'::text, e_1.unique_name, c.logiccond_comparator, format('''%s'''::text, c.logiccond_value)) AS format
                  FROM (common_dd.t_core_logiccond c
                    LEFT JOIN common_dd.t_core_element_hierarchy e_1 ON ((e_1.key_element = c.fk_variable)))
                 WHERE (c.compare_variables = 0)
               UNION
                SELECT c.fk_andgrp,
                   format('[%s]%s[%s]'::text, e_1.unique_name, c.logiccond_comparator, r.unique_name) AS format
                  FROM ((common_dd.t_core_logiccond c
                    LEFT JOIN common_dd.t_core_element_hierarchy e_1 ON ((e_1.key_element = c.fk_variable)))
                    LEFT JOIN common_dd.t_core_element_hierarchy r ON ((r.key_element = c.fk_variable2)))
                 WHERE (c.compare_variables = 1)
               ), ors(fk_orgrp, redcaprule) AS (
                SELECT a.fk_orgrp,
                   string_agg(x_1.redcaprule, ' and '::text) AS string_agg
                  FROM (ands x_1
                    LEFT JOIN common_dd.t_core_logicandgrp a ON ((a.andgrp = x_1.fk_andrgp)))
                 GROUP BY a.fk_orgrp
               )
        SELECT e.unique_name,
           t.logictype_descr,
           string_agg(format('(%s)'::text, x.redcaprule), ' or '::text) AS redcaprule
          FROM (((ors x
            LEFT JOIN common_dd.t_core_logic l ON ((l.fk_orgrp = x.fk_orgrp)))
            LEFT JOIN common_dd.t_core_logictype t ON ((t.logictype = l.fk_logictype)))
            LEFT JOIN common_dd.t_core_element_hierarchy e ON ((e.key_element = l.fk_variable)))
         GROUP BY e.unique_name, t.logictype_descr;
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_redcap_logic</code> table reference
     */
    public VRedcapLogic(String alias) {
        this(DSL.name(alias), V_REDCAP_LOGIC);
    }

    /**
     * Create an aliased <code>common_dd.v_redcap_logic</code> table reference
     */
    public VRedcapLogic(Name alias) {
        this(alias, V_REDCAP_LOGIC);
    }

    /**
     * Create a <code>common_dd.v_redcap_logic</code> table reference
     */
    public VRedcapLogic() {
        this(DSL.name("v_redcap_logic"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VRedcapLogic as(String alias) {
        return new VRedcapLogic(DSL.name(alias), this);
    }

    @Override
    public VRedcapLogic as(Name alias) {
        return new VRedcapLogic(alias, this);
    }

    @Override
    public VRedcapLogic as(Table<?> alias) {
        return new VRedcapLogic(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VRedcapLogic rename(String name) {
        return new VRedcapLogic(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VRedcapLogic rename(Name name) {
        return new VRedcapLogic(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VRedcapLogic rename(Table<?> name) {
        return new VRedcapLogic(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VRedcapLogic where(Condition condition) {
        return new VRedcapLogic(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VRedcapLogic where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VRedcapLogic where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VRedcapLogic where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VRedcapLogic where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VRedcapLogic where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VRedcapLogic where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VRedcapLogic where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VRedcapLogic whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VRedcapLogic whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
